make.bash 6.15 KB
Newer Older
1
#!/usr/bin/env bash
2 3 4 5
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

6 7
# See golang.org/s/go15bootstrap for an overview of the build process.

Russ Cox's avatar
Russ Cox committed
8 9 10 11 12 13 14 15 16 17 18 19 20 21
# Environment variables that control make.bash:
#
# GOROOT_FINAL: The expected final Go root, baked into binaries.
# The default is the location of the Go tree during the build.
#
# GOHOSTARCH: The architecture for host tools (compilers and
# binaries).  Binaries of this type must be executable on the current
# system, so the only common reason to set this is to set
# GOHOSTARCH=386 on an amd64 machine.
#
# GOARCH: The target architecture for installed packages and tools.
#
# GOOS: The target operating system for installed packages and tools.
#
22
# GO_GCFLAGS: Additional go tool compile arguments to use when
Russ Cox's avatar
Russ Cox committed
23 24
# building the packages and commands.
#
25
# GO_LDFLAGS: Additional go tool link arguments to use when
26
# building the commands.
Russ Cox's avatar
Russ Cox committed
27
#
28 29 30
# CGO_ENABLED: Controls cgo usage during the build. Set it to 1
# to include all cgo related files, .c and .go file with "cgo"
# build directive, in the build. Set it to 0 to ignore them.
Russ Cox's avatar
Russ Cox committed
31
#
32 33 34 35 36
# GO_EXTLINK_ENABLED: Set to 1 to invoke the host linker when building
# packages that use cgo.  Set to 0 to do all linking internally.  This
# controls the default behavior of the linker's -linkmode option.  The
# default value depends on the system.
#
37
# CC: Command line to run to compile C code for GOHOSTARCH.
Russ Cox's avatar
Russ Cox committed
38
# Default is "gcc". Also supported: "clang".
39 40 41 42 43 44 45
#
# CC_FOR_TARGET: Command line to run to compile C code for GOARCH.
# This is used by cgo.  Default is CC.
#
# CXX_FOR_TARGET: Command line to run to compile C++ code for GOARCH.
# This is used by cgo. Default is CXX, or, if that is not set, 
# "g++" or "clang++".
46
#
47 48 49
# FC: Command line to run to compile Fortran code for GOARCH.
# This is used by cgo. Default is "gfortran".
#
50 51
# PKG_CONFIG: Path to pkg-config tool. Default is "pkg-config".
#
52
# GO_DISTFLAGS: extra flags to provide to "dist bootstrap".
53
# (Or just pass them to the make.bash command line.)
54 55 56 57
#
# GOBUILDTIMELOGFILE: If set, make.bash and all.bash write
# timing information to this file. Useful for profiling where the
# time goes when these scripts run.
58 59 60 61
#
# GOROOT_BOOTSTRAP: A working Go tree >= Go 1.4 for bootstrap.
# If $GOROOT_BOOTSTRAP/bin/go is missing, $(go env GOROOT) is
# tried for all "go" in $PATH. $HOME/go1.4 by default.
Russ Cox's avatar
Russ Cox committed
62

63
set -e
64 65 66

unset GOBIN # Issue 14340

Russ Cox's avatar
Russ Cox committed
67
if [ ! -f run.bash ]; then
68 69 70
	echo 'make.bash must be run from $GOROOT/src' 1>&2
	exit 1
fi
71

72 73 74 75
if [ "$GOBUILDTIMELOGFILE" != "" ]; then
	echo $(date) start make.bash >"$GOBUILDTIMELOGFILE"
fi

Russ Cox's avatar
Russ Cox committed
76 77 78 79 80 81 82 83 84 85
# Test for Windows.
case "$(uname)" in
*MINGW* | *WIN32* | *CYGWIN*)
	echo 'ERROR: Do not use make.bash to build on Windows.'
	echo 'Use make.bat instead.'
	echo
	exit 1
	;;
esac

Russ Cox's avatar
Russ Cox committed
86
# Test for bad ld.
87
if ld --version 2>&1 | grep 'gold.* 2\.20' >/dev/null; then
88 89 90 91 92 93 94 95 96 97
	echo 'ERROR: Your system has gold 2.20 installed.'
	echo 'This version is shipped by Ubuntu even though'
	echo 'it is known not to work on Ubuntu.'
	echo 'Binaries built with this linker are likely to fail in mysterious ways.'
	echo
	echo 'Run sudo apt-get remove binutils-gold.'
	echo
	exit 1
fi

Russ Cox's avatar
Russ Cox committed
98 99 100
# Test for bad SELinux.
# On Fedora 16 the selinux filesystem is mounted at /sys/fs/selinux,
# so loop through the possible selinux mount points.
101 102 103 104 105 106 107 108 109 110 111 112 113
for se_mount in /selinux /sys/fs/selinux
do
	if [ -d $se_mount -a -f $se_mount/booleans/allow_execstack -a -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
		if ! cat $se_mount/booleans/allow_execstack | grep -c '^1 1$' >> /dev/null ; then
			echo "WARNING: the default SELinux policy on, at least, Fedora 12 breaks "
			echo "Go. You can enable the features that Go needs via the following "
			echo "command (as root):"
			echo "  # setsebool -P allow_execstack 1"
			echo
			echo "Note that this affects your system globally! "
			echo
			echo "The build will continue in five seconds in case we "
			echo "misdiagnosed the issue..."
114

115 116
			sleep 5
		fi
117
	fi
118
done
119

120 121 122
# Test for debian/kFreeBSD.
# cmd/dist will detect kFreeBSD as freebsd/$GOARCH, but we need to
# disable cgo manually.
123
if [ "$(uname -s)" = "GNU/kFreeBSD" ]; then
124
	export CGO_ENABLED=0
125 126
fi

Russ Cox's avatar
Russ Cox committed
127
# Clean old generated file that will cause problems in the build.
128
rm -f ./runtime/runtime_defs.go
Russ Cox's avatar
Russ Cox committed
129

Russ Cox's avatar
Russ Cox committed
130
# Finally!  Run the build.
Russ Cox's avatar
Russ Cox committed
131

132 133 134 135 136 137 138 139
verbose=false
vflag=""
if [ "$1" = "-v" ]; then
	verbose=true
	vflag=-v
	shift
fi

140
export GOROOT_BOOTSTRAP=${GOROOT_BOOTSTRAP:-$HOME/go1.4}
141
export GOROOT="$(cd .. && pwd)"
142
IFS=$'\n'; for go_exe in $(type -ap go); do
143
	if [ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]; then
144
		goroot=$(GOROOT='' "$go_exe" env GOROOT)
145 146 147 148
		if [ "$goroot" != "$GOROOT" ]; then
			GOROOT_BOOTSTRAP=$goroot
		fi
	fi
149 150 151 152 153
done; unset IFS
echo "Building Go cmd/dist using $GOROOT_BOOTSTRAP."
if $verbose; then
	echo cmd/dist
fi
154 155 156
if [ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]; then
	echo "ERROR: Cannot find $GOROOT_BOOTSTRAP/bin/go." >&2
	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go 1.4." >&2
157 158
	exit 1
fi
159
if [ "$GOROOT_BOOTSTRAP" = "$GOROOT" ]; then
160 161 162
	echo "ERROR: \$GOROOT_BOOTSTRAP must not be set to \$GOROOT" >&2
	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go 1.4." >&2
	exit 1
163
fi
164
rm -f cmd/dist/dist
165
GOROOT="$GOROOT_BOOTSTRAP" GOOS="" GOARCH="" "$GOROOT_BOOTSTRAP/bin/go" build -o cmd/dist/dist ./cmd/dist
166

Rob Pike's avatar
Rob Pike committed
167 168 169 170 171 172
# -e doesn't propagate out of eval, so check success by hand.
eval $(./cmd/dist/dist env -p || echo FAIL=true)
if [ "$FAIL" = true ]; then
	exit 1
fi

173 174 175
if $verbose; then
	echo
fi
176

Russ Cox's avatar
Russ Cox committed
177 178
if [ "$1" = "--dist-tool" ]; then
	# Stop after building dist tool.
179
	mkdir -p "$GOTOOLDIR"
180 181 182
	if [ "$2" != "" ]; then
		cp cmd/dist/dist "$2"
	fi
183
	mv cmd/dist/dist "$GOTOOLDIR"/dist
Russ Cox's avatar
Russ Cox committed
184 185 186
	exit 0
fi

187 188 189
buildall="-a"
if [ "$1" = "--no-clean" ]; then
	buildall=""
Russ Cox's avatar
Russ Cox committed
190
	shift
191
fi
192

193 194 195
# Run dist bootstrap to complete make.bash.
# Bootstrap installs a proper cmd/dist, built with the new toolchain.
# Throw ours, built with Go 1.4, away after bootstrap.
196
./cmd/dist/dist bootstrap $buildall $vflag $GO_DISTFLAGS "$@"
197 198 199 200 201 202 203
rm -f ./cmd/dist/dist

# DO NOT ADD ANY NEW CODE HERE.
# The bootstrap+rm above are the final step of make.bash.
# If something must be added, add it to cmd/dist's cmdbootstrap,
# to avoid needing three copies in three different shell languages
# (make.bash, make.bat, make.rc).